import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;
import java.util.*;

/**
 * Screen
 * 
 * @author Taylor Born
 * @version November 2011
 */
public class Screen extends World
{
    private GreenfootImage origW = new GreenfootImage("Wolf.jpg");
    private Font font = new Font("Arial", Font.BOLD, 50);
    private int step = 0;
    private ArrayList<Spot> spots = new ArrayList<Spot>();
    private String text;
    private static final int CODE_ID = 58;

    public Screen()
    {
        super(600, 400, 1);
        CodeKeyUser.enter();
        if (CodeGenerator.haveUser())
            text = CodeGenerator.getCode(CODE_ID);
        else
            text = "CAN YOU SEE ME?";
        for (int i = 0; i < 15; i++)
            spots.add(new Spot(origW.getWidth(), origW.getHeight()));
        updateBack();
        Greenfoot.start();
    }
    public void act()
    {
        if (++step == 700)
            step = 0;
        if (Greenfoot.isKeyDown("space"))
            for (Spot s : spots)
                s.move(origW.getWidth(), origW.getHeight());
        updateBack();
    }
    public void updateBack()
    {
        GreenfootImage pic = new GreenfootImage(origW);
        pic.setColor(Color.WHITE);
        pic.setFont(font);
        if (Greenfoot.isKeyDown("space"))
        {
            for (Spot s : spots)
                pic.fillOval(s.getX() - s.getRadius(), s.getY() - s.getRadius(), s.getRadius() * 2, s.getRadius() * 2);
        }
        
        pic.drawString(text, pic.getWidth() - step, pic.getHeight() - 15);
        
        for (int i = 0; i < pic.getHeight(); i++)
            for (int k = 0; k < pic.getWidth(); k++)
            {
                Color c = pic.getColorAt(k, i);
                int n = (int)(c.getRed() * .3d + c.getGreen() * .59d + c.getBlue() * .11d);
                int num = (int)(255 - (double)n / 255 * 30);
                pic.setColorAt(k, i, new Color(num, num, num));
            }
        pic.setColor(Color.BLACK);
        for (int i = 0; i < pic.getWidth(); i += 5)
            pic.fillRect(i, 0, 3, pic.getHeight());
        GreenfootImage back = new GreenfootImage(600, 400);
        back.drawImage(pic, 300 - pic.getWidth() / 2, 200 - pic.getHeight() / 2);
        setBackground(back);
    }
}